
# include <SR/sr_output.h>

# include "semesh_main_win.h"
# include "semesh_mesh.h"

// Globals:
MainWin*      TheMainWin;
GuiColorWin*  TheColorWin;
SymEdge*      TheRedSymEdge;
SymEdge*      TheBlueSymEdge;
SrPnt*        ThePoint;
Mesh*         TheMesh;

// Main:
int main ()
 {
   TheMesh = new Mesh;
   TheMesh->output_errors ( false );
   TheMesh->safe_mode ( true );

   TheRedSymEdge = TheMesh->init ( SrPnt(-0.5f,0,0), SrPnt(0.5f,0,0) );
   TheBlueSymEdge = TheRedSymEdge->sym();
   ThePoint = new SrPnt;

   TheColorWin = new GuiColorWin;
   TheMainWin = new MainWin;
   TheMainWin->viewer->draw_mesh();
   TheMainWin->viewer->draw_parms();
   TheMainWin->render();
   TheMainWin->show();

   Fl::run();

   return 0;
 }

