
# ifndef SRMESH_VIEWER_H
# define SRMESH_VIEWER_H

# include <SR/sr_viewer.h>
# include <SR/sr_sn_shape.h>
# include <SR/sr_lines.h>
# include <SR/sr_points.h>
# include <SR/sr_sn_group.h>

class Viewer : public SrViewer
 { private :
    SrSnPoints*   _vertices;
    SrSnLines*    _edges;
    SrSnGroup*    _faces;
    SrSnLines*    _redsym;
    SrSnLines*    _bluesym;
    SrSnPoints*   _point;
   public :
    Viewer ( int x, int y, int w, int h );
    void visibility ( bool v, bool e, bool f, bool r, bool b, bool p );
    void draw_parms ();
    void draw_mesh ();

   public :
    virtual int handle_event ( const SrEvent &e );
    virtual int handle_keyboard ( const SrEvent& e );
    virtual int handle_scene_event ( const SrEvent& e );
 };

# endif // SRMESH_VIEWER_H
