
# include <FL/fl_ask.H>
# include <FL/fl_file_chooser.H>
# include <FL/Fl_Color_Chooser.H>

# include <SR/sr_output_window.h>

# include <SR/sr_string.h>
# include <SR/sr_model.h>
# include <SR/sr_lines.h>
# include <SR/sr_sn_group.h>
# include <SR/sr_sn_shape.h>

# include "srm_main.h"
# include "srm_main_win.h"
# include "srm_material_tab.h"

//# define SR_USE_TRACE1 
# include <SR/sr_trace.h>

SrmMainWin*      TheMainWin;
SrmMaterialTab*  TheMaterialTab;

void open_numbered ( const char* prim )
 {
   SrString dir ( "C:/kallmann/worksave/primmodels/" );
   SrString s;
   s=dir; s<<"init0000.srm"; TheMainWin->open_numbered(s);
   s=dir; s<<prim<<"025_0000.srm"; TheMainWin->open_numbered(s);
   s=dir; s<<prim<<"075_0000.srm"; TheMainWin->open_numbered(s);
   s=dir; s<<prim<<"050_0000.srm"; TheMainWin->open_numbered(s);
   s=dir; s<<prim<<"100_0000.srm"; TheMainWin->open_numbered(s);
 }

int main ( int argc, char **argv )
 {
   TheMainWin = new SrmMainWin;
   TheMaterialTab = new SrmMaterialTab(TheMainWin);

   SrOutputWindow ow(sr_out);

   if ( argc>1 )
    { TheMainWin->open ( argv[1] );
    }
   else if (0)
    {
      TheMainWin->open ( "../../data/rivers/rivgeo_head.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_hip.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_lfoot.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_lleg.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_lthigh.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_lowertorso.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_uppertorso.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_neck.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_rfoot.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_rleg.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_rthigh.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_rupperarm.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_rhand.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_rlowerarm.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_lupperarm.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_llowerarm.srm" );
      TheMainWin->open ( "../../data/rivers/rivgeo_lhand.srm" );

      TheMainWin->open ( "../../data/objects/shelf.srm" );
      TheMainWin->open ( "../../data/objects/lampsmall.srm" );
      TheMainWin->open ( "../../data/objects/floor.srm" );
      TheMainWin->open ( "../../data/objects/bookred.srm" );
    }
   else if (0)
    { open_numbered ( "ur" );
      //open_numbered ( "ul" );
      //open_numbered ( "lr" );
      open_numbered ( "ll" );
    }

   //TheMainWin->open ( "../../data/newrivers/rivers_rupperarm2.srm" );
   //TheMainWin->open ( "../../data/rivers/rivers_head.srm" );

   TheMainWin->ui_viewer->menu_cmd ( SrViewer::CmdAxis );
   TheMainWin->ui_window->show();
   TheMainWin->ui_viewer->view_all();

   Fl::run();

   return 0;
 }

