
# ifndef SRM_MAIN_WIN_H
# define SRM_MAIN_WIN_H

# include "srm_ui.h"
# include <SR/sr_matrix_window.h>

class SrmMatWin : public SrMatrixWindow
 { public :
    SrSnManipulator* manip;
    SrmViewer* viewer;
    SrMat restore_mat;
   public :
    virtual void matrix_changed ( const SrMat& m );
    virtual void cancel_button (); // will restore the matrix
 };

class SrmMainWin : public UiMainWin
 { private :
    float _last_crease_angle_deg;
    float _last_normals_prec_deg;
    SrmMatWin* _matwin;
    SrString _lastdir;

   public :
    SrmMainWin ();
   ~SrmMainWin ();
    bool open ( const char *file=0 );
    void update_ui ();
    void add_model ( SrSnModel* sm, const char* filename );

    SrSnModel* cur_smodel () const;
    SrModel* cur_model () const;
    void cur_close ();
    void open_numbered ( const char* first_file=0 );
    void open_dir ( const char* folder=0 );

    void add_primitive ( SrmMainEvent type, const char* coords=0 );

   public :
    virtual void event ( SrmMainEvent e );
    virtual void event ( SrmMtlTabEvent e );
 };

# endif // SRM_MAIN_WIN_H
