
# include <string.h>

# include <SR/sr_string.h>
# include <SR/sr_array.h>

/* We use this Buf class because SrArray cannot be used with classes having
   internal dynamic memory managements. */

struct Buf
 { char st[80];
   Buf ( char *s ) { strcpy_s(st,80,s); }
   void operator = ( const Buf &b ) { strcpy_s(st,20,b.st); }
   friend SrOutput& operator<< ( SrOutput& o, const Buf &b ) { return o<<(char*)b.st; }
   friend SrInput& operator>> ( SrInput& i, Buf &b ) { return i>>b.st; }
   friend int sr_compare  ( const Buf *b1, const Buf *b2 ) { return sr_compare((char*)b1->st,(char*)b2->st); }
 };

static void run ()
 {
   SrArray<Buf> a;
   sr_out << "Empty:  " << a << '\n';

   a.push() = Buf("The");
   a.push() = Buf("book");
   a.push() = Buf("IS");
   a.push() = Buf("on");
   a.push() = Buf("the");
   a.push() = Buf("table");
   sr_out << "Push:   " << a << '\n';

   a.sort (sr_compare);
   sr_out << "Sorted: " << a << '\n';

   a.insort ( Buf("inserted1"), sr_compare );
   a.insort ( Buf("inserted2"), sr_compare );
   a.insort ( Buf("aaa"), sr_compare );
   a.insort ( Buf("zzz"), sr_compare );
   sr_out << "Insort: " << a << '\n';

   SrString buf;
   SrOutput o(buf);
   o << a;
   sr_out << "StrOut: " << buf << '\n'; 
  
   SrArray<Buf> b;
   SrInput in(buf);
   in >> b;
   sr_out << "StrInp: " << b << '\n'; 

   SrArray<Buf> c=b;
   sr_out << "Copy:   " << c << '\n';
 }

int array_main ( int, char ** )
 {
   run ();
   return 0;
 }
