
# include <SR/sr_gl.h>
# include <SR/sr_camera.h>
# include <SR/sr_trackball.h>
# include <SR/sr_light.h>
# include <SR/sr_sn.h>
# include <SR/sr_sa_gl_render.h>
# include <SR/sr_sa_bbox.h>

//==================================== GlutViewer ===============================

class SrGlutViewer
 { private :
    int _win_dx, _win_dy;
    SrSaGlRender _ra;
    SrSaBBox _ba;
    SrTrackball _tb;
    SrCamera _cam;
    SrBox _bbox;
    SrMat _mat;
    SrLight _light;
    SrSn* _root;
    const char* _win_title;
    float mousex, mousey, lmousex, lmousey;
    //SrQuat rotdelta;
   public :
    SrGlutViewer ( const char* title );
    void show ();
    void run ();
    void root ( SrSn *r );
    SrSn* root () { return _root; }
    void view_all ();
   public :
    void reshape ( int width, int height );
    void keyboard ( unsigned char key, int x, int y );
    void mouse ( int button, int state, int x, int y );
    void motion ( int x, int y );
    void display ();
 };

