
# include <SR/sr_string.h>
# include <SR/sr_vec2.h>
# include <SR/sr_color.h>
# include <SR/sr_graph.h>

class MyNode;

class MyLink : public SrGraphLink
 { public :
    SrString s;
   public :
    SR_GRAPH_LINK_CASTED_METHODS(MyNode,MyLink);

    MyLink () { s="link"; }
    MyLink ( const MyLink& l ) : s(l.s) {}
   ~MyLink () {}

    friend SrOutput& operator<< ( SrOutput& out, const MyLink& l )
     { return out<<'"'<<l.s<<'"'; }

    friend SrInput& operator>> ( SrInput& inp, MyLink& l )
     { return inp>>l.s; }

    friend int sr_compare ( const MyLink* l1, const MyLink* l2 )
     { return 0; }
 };

class MyNode : public SrGraphNode
 { public :
    SrString s;
   public :
    SR_GRAPH_NODE_CASTED_METHODS(MyNode,MyLink);

    MyNode () { s="node"; }
    MyNode ( const MyNode& n ) : s(n.s) {}
    MyNode ( const char* st ) { s="node"; s<<" "; s<<st; }
   ~MyNode () {}

    friend SrOutput& operator<< ( SrOutput& out, const MyNode& n )
     {return out<<'\"'<<n.s<<'\"'; }

    friend SrInput& operator>> ( SrInput& inp, MyNode& n )
     { return inp>>n.s; }

    friend int sr_compare ( const MyNode* n1, const MyNode* n2 )
     { return 0; }
 };

typedef SrGraph<MyNode,MyLink> MyGraph;

static void run ()
 {
   MyGraph g;

   MyNode* n0 = g.insert ( new MyNode("n0") );
   MyNode* n1 = g.insert ( new MyNode("n1") );
   MyNode* n2 = g.insert ( new MyNode("n2") );
   MyNode* n3 = g.insert ( new MyNode("n3") );

   g.link ( n1, n2, 12 );
   n1->link(n2)->s << " 12";
   n1->linkto ( n3, 13 )->s << " 13";

   sr_out<<g<<srnl;

   SrListIterator<MyNode> it ( g.first_node() );
   for ( it.first(); it.inrange(); it.next() ) sr_out<<it->s<<srnl;
 }

int graph_main ( int, char ** )
 {
   run ();
   return 0;
 }
