
# include <SR/sr_grid.h>

void out ( SrGridBase& g )
 {
   sr_out << "Dim:   " << g.dimensions() << srnl;
   sr_out << "Cells: " << g.cells() << srnl;
   sr_out << srnl;
 }

void test4x4 ()
 {
   SrGridBase g;
   int cell;
   SrArray<int> c;

   g.init ( 4, 3 );
   c.size(4);

   int i, j, k, t;

   for ( t=0; t<3; t++ )
    for ( k=0; k<3; k++ )
     for ( j=0; j<3; j++ )
      for ( i=0; i<3; i++ )
        { c[0]=i; c[1]=j; c[2]=k; c[3]=t; 
          cell = g.cell_index(c);
          sr_out << i << "," << j << "," << k << "," << t << ": "
                 << cell << srnl;
        }

   out ( g );
 }

struct Data
 { int index;
   double data;
 };

int grid_main ( int, char ** )
 {
   SrGrid<Data> g;
   SrArray<SrGridAxis> ax;

   ax.size(2);
   ax[0].min = 1.0f;
   ax[0].max = 5.0f;
   ax[0].segs = 4;
   ax[1].min = 1.0f;
   ax[1].max = 2.0f;
   ax[1].segs = 3;

   g.init ( ax );

   int idx, i, j;

   for ( idx=0; idx<g.cells(); idx++ )
    g[idx].index = idx;

   for ( idx=0; idx<g.cells(); idx++ )
    { g.cell_coords(idx,i,j);
      sr_out << i << "," << j << ": " << idx << srnl;
    }

   SrPnt2 a, b;
   for ( idx=0; idx<g.cells(); idx++ )
    { g.cell_coords(idx,i,j);
      g.cell_boundary(i,j,a,b);
      sr_out << i << "," << j << ": ";
      sr_out << a << "; " << b << srnl;
    }

   SrArray<int> cells;
   a.set ( 1.0f, 1.0f );
   b.set ( 3.0f, 2.0f );
   g.get_intersection ( a, b, cells );
   sr_out<<"Intersection: ";
   for ( idx=0; idx<cells.size(); idx++ )
    sr_out<<cells[idx]<<srspc;
   sr_out<<srnl;

   out ( g );

   return 0;
 }
