
# include <stdlib.h>
# include <stdio.h>

# include <FL/Fl.H>
# include <FL/fl_file_chooser.H>
# include <FL/Fl_Value_Slider.H>
# include <FL/fl_ask.H>

# include <SR/sr_sn_polygon_editor.h>
# include <SR/sr_viewer.h>

int H = 350;
int W = 500;
SrViewer* viewer;
Fl_Value_Slider* slider;
SrSnPolygonEditor* polygons;
SrPolygons polref;

void cb_slider ( Fl_Value_Slider* slider, void* v )
 {
   if ( polref.size()==0 )
    { fl_alert ("First draw a polygon and press Init!");
      return;
    }
    
   int i;
   polygons->init();
   for ( i=0; i<polref.size(); i++ )
    { polygons->shape().push() = polref[i];
      polygons->shape().top().grow ( (float)slider->value(), SR_TORAD(5) );

    }
   viewer->render();
 }

void cb_init ( Fl_Button* but, void* v )
 {
   int i;
   polref.init();
   for ( i=0; i<polygons->shape().size(); i++ )
    { polref.push() = polygons->shape().get(i);
      if ( polref.top().area()<0 ) polref.top().reverse();
    }
 }

void cb_clear ( Fl_Button* but, void* v )
 {
   polref.init();
   polygons->init();
   viewer->render();
   slider->value(0);
 }

int grow_main ( int argc, char **argv )
 {
   Fl_Window* window = new Fl_Window ( 400, 50, W, H );

   viewer = new SrViewer ( 2, 0, W, H-40 );
   window->label ( "SrPolygon Grow Test" );
   viewer->menu_cmd ( SrViewer::CmdPlanar );
   viewer->menu_cmd ( SrViewer::CmdAxis );
   viewer->end();

   Fl_Button* but_clear = new Fl_Button(0, H-35, 40, 35, "Clear");
   but_clear->callback( (Fl_Callback*)cb_clear );

   Fl_Button* but_init = new Fl_Button(45, H-35, 40, 35, "Init");
   but_init->callback( (Fl_Callback*)cb_init );

   slider = new Fl_Value_Slider(90, H-35, W-45, 35, "");
   slider->type(1);
   slider->maximum(0.5);
   slider->minimum(-0.5);
   slider->value(0);
   slider->callback( (Fl_Callback*)cb_slider );

   window->end();
   window->show();

   polygons = new SrSnPolygonEditor;
   polygons->solid ( false );

   viewer->root ( polygons );
   viewer->view_all();

   Fl::run();

   return 0;
 }
