
# include <SR/sr_string.h>
# include <SR/sr_list.h>

class MyData : public SrListNode
 { public :
    SrString s;
   public :
    MyData () {}
    MyData ( const char* st ) { s=st; }
    MyData ( const MyData& d ) { s=d.s; }
   ~MyData () {}
    friend SrOutput& operator<< ( SrOutput& out, const MyData& c ) { return out<<c.s; }
    friend SrInput& operator>> ( SrInput& inp, MyData& c ) { return inp>>c.s; }
    friend int sr_compare ( const MyData* c1, const MyData* c2 ) { return sr_compare(c1->s,c2->s); }
 };

static void run ()
 {
   SrList<MyData> l;

   l.insert_next ( new MyData("E1") );
   l.insert_next ( new MyData("E5") );
   l.insert_next ( new MyData("E3") );
   l.sort();
   sr_out<<l<<srnl;

   { SrList<MyData> nl(l);
     nl.insort ( new MyData("E2") );
     nl.insort ( new MyData("E4") );
     sr_out<<nl<<srnl;
     l = nl;
   }

   SrListIterator<MyData> it(l);
   for ( it.first(); it.inrange(); it.next() ) sr_out<<it->s<< ' ';
   for ( it.last(); it.inrange(); it.prior() ) sr_out<<it->s<< ' ';
   sr_out<<srnl;

   MyData key("E1");
   l.search(&key); l.remove();
   it.reset();
   for ( it.first(); it.inrange(); it.next() ) sr_out<<it->s<< ' ';
   for ( it.last(); it.inrange(); it.prior() ) sr_out<<it->s<< ' ';
   sr_out<<srnl;

   l.push_front ( new MyData("F1") );
   l.push_front ( new MyData("F2") );
   l.push_back ( new MyData("B1") );
   l.push_back ( new MyData("B2") );
   sr_out<<l<<srnl;

   delete l.pop_front ();
   delete l.pop_back ();
   sr_out<<l<<srnl;
 }

int list_main ( int, char ** )
 {
   run ();
   return 0;
 }
