 
# include <math.h>

# include <SR/sr_mat.h>
# include <SR/sr_timer.h>
# include <SR/sr_random.h>

# define MAX 5000

// I've found big errors when testing over 50000 iterations

int matinv_main ( int, char ** )
 {
   SrMat m ( 2, 3, 4, 5, 
             6, 7, 8, 9,
             1, 2, 3, 4, 
             5, 6, 7, 8 );

   int i, j;
   SrTimer t;
   SrRandom r;
   float d, dmax=0;
   SrMat minv, p, pmax(SrMat::id);

   t.start ();
   for ( i=0; i<MAX; i++ )
    { for ( j=0; j<15; j++ ) m[j] = r.get(-1.0f,1.0f);
      m.inverse ( minv );
      p.mult ( m, minv );
      d = dist2 ( p, SrMat::id );
      if ( d>dmax ) { dmax=d; pmax=m; }
    }
   t.stop ();
   sr_out << "SrMat time for " << MAX << " inversions: " << t.dt() << srnl;
   sr_out << "Max error: " << (float) sqrtf(dmax) << srnl;
   
   pmax.inverse(minv);
   sr_out << srnl << pmax << srnl << minv << srnl << (pmax*minv);

   return 0;
 }
