
# include <stdio.h>

# include <SR/sr_random.h>
# include <SR/sr.h>

double lastn, sum, total;
int l, c, mlin, mcol;
SrRandom r;

void init_print ( int lin, int col )
 {
   lastn=0; sum=0; total=-1;
   l = 0;
   c = 0;
   mlin = lin;
   mcol = col;
   if ( r.type()=='i' )
    printf ("\nRandom integers from %d to %d...\n", (int)r.inf(), (int)r.sup() );
   else if ( r.type()=='f' )
    printf ("\nRandom floats from %f to %f...\n", (float)r.inf(), (float)r.sup() );
   else
    printf ("\nRandom doubles from %lf to %lf...\n", r.inf(), r.sup() );
 }

bool printing ()
 {
   sum += lastn;
   total += 1;

   c++;
   if ( c>mcol )
    { c=1;
      l++;
      printf ( "\n" );
      if ( l>=mlin )
       { printf ("Mean: %f\n", sum/total );
         return false;
       }
    }
   return true;
 }

void test ( double d )
 {
   if ( !SR_BOUNDED(d,r.inf(),r.sup()) ) printf("ERROR!\n"); 
 }

int random_main ( int, char ** )
 {
   r.limits ( 0, 1 );
   init_print ( 3, 20 );
   while ( printing() )
    { lastn = r.geti();
      test ( lastn );
      printf ( "%2d ", int(lastn) );
    }

   r.limits ( -32000.0f, 32000.0f, 30 );
   init_print ( 5, 6 );
   while ( printing() )
    { lastn = r.getf();
      test ( lastn );
      printf ( "%f ", float(lastn) );
    }

   r.limits ( -20.23, 20.23 );
   init_print ( 5, 6 );
   while ( printing() )
    { lastn = r.getd();
      test ( lastn );
      printf ( "%f ", lastn );
    }

   return 0;
 }
