 
# include <stdlib.h>

# include <FL/Fl.H>

# include <SR/sr_vec.h>
# include <SR/sr_event.h>
# include <SR/sr_camera.h>
# include <SR/sr_box.h>
# include <SR/sr_sphere.h>
# include <SR/sr_cylinder.h>
# include <SR/sr_model.h>
# include <SR/sr_lines.h>
# include <SR/sr_sn_group.h>
# include <SR/sr_sn_matrix.h>
# include <SR/sr_sn_shape.h>
# include <SR/sr_viewer.h>
# include <SR/sr_output.h>

class MyViewer : public SrViewer
 { public :
    MyViewer ( int x, int y, int w, int h ) : SrViewer(x,y,w,h) {}
    virtual void init_opengl ( int w, int h );
 };

# include <SR/sr_gl.h>

void MyViewer::init_opengl ( int w, int h )
    {
   //sr_out<<"INIT"<<srnl;
   //glViewport ( 0, 0, w, h );
   //glEnable ( GL_DEPTH_TEST );
   glEnable ( GL_LIGHT0 ); 
   glEnable ( GL_LIGHTING );
   //glEnable ( GL_BLEND ); // for transparency
   //glBlendFunc ( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );

   glCullFace ( GL_BACK );
   //glDepthFunc ( GL_LEQUAL );

   //glFrontFace ( GL_CW );
 }

// put axis w/ bbox size and unit marks
int scene_main ( int, char ** )
 {
   SrSnGroup* g = new SrSnGroup;
   SrSnGroup* g1 = new SrSnGroup;
   SrSnGroup* g2 = new SrSnGroup;
   SrSnGroup* g3 = new SrSnGroup;

   SrSnBox* box = new SrSnBox;
   SrSnSphere* sph = new SrSnSphere;
   SrSnCylinder* cyl = new SrSnCylinder;

   SrMat mat;
   mat.scale ( 0.25f, 0.25f, 0.25f );
   mat.setl4 ( -0.9f, -0.125, -0.125, 1 );
   g1->separator ( true );
   g1->add ( new SrSnMatrix(mat) );
   g1->add ( box );

   mat.identity ();
   mat.scale ( 0.3f, 0.3f, 0.3f );
   g2->separator ( true );
   g2->add ( new SrSnMatrix(mat) );
   g2->add ( sph );

   mat.identity ();
   mat.scale ( 0.5f, 2.5f, 1.5f );
   mat.setl4 ( 0.4f, 0, 0, 1.0f );
   g3->separator ( true );
   g3->add ( new SrSnMatrix(mat) );
   g3->add ( cyl );

   g->add ( g1 );
   g->add ( g2 );
   g->add ( g3 );

   SrViewer* v = new MyViewer ( 385, 50, 350, 280 );
   v->menu_cmd ( SrViewer::CmdAxis );
   v->root ( g );
   v->show();

   Fl::run();

   return 0;
 }
