
# include <SR/sr_string.h>
# include <SR/sr_set.h>

class MySetData
 { public :
    SrString s;
   public :
    MySetData () {}
    MySetData ( const MySetData& d ) { s=d.s; }
   ~MySetData () {}
    friend SrOutput& operator<< ( SrOutput& out, const MySetData& c ) { return out<<c.s; }
    friend SrInput& operator>> ( SrInput& inp, MySetData& c ) { return inp>>c.s; }
    friend int sr_compare ( const MySetData* c1, const MySetData* c2 ) { return sr_compare(c1->s,c2->s); }
 };

static void run ()
 {
   SrSet<MySetData> set;
   int i, id;
   for ( i=0; i<10; i++ ) set[set.insert()]->s.setf("E%d",i);

   sr_out << "Orig Set: " << set << srnl;

   set.remove ( 2 );
   set.remove ( 6 );
   set.remove ( 8 );
   set.remove ( 7 );
   sr_out << "Rem 2,6,8,7: " << set << srnl;

   set.remove ( 9 );
   sr_out << "Rem 9   : " << set << srnl;

   SrSet<MySetData> copyset(set); // for later on tests

   id=set.insert(); set[id]->s="xx";
   sr_out << "Ins xx  : " << set << srnl;

   SrArray<int> newids;
   set.remove_gaps(newids);
   sr_out << "Rem gaps: " << set << srnl;
   sr_out << "New ids : " << newids << srnl;

   // copyset tests
   SrString buf;
   SrOutput out ( buf );
   out << copyset;
   SrInput inp(buf);
   inp.lowercase_tokens(false);
   inp >> set;

   sr_out << srnl << "I/O test:" << srnl;
   sr_out << copyset << " maxid=" << copyset.maxid() << srnl;   
   sr_out << set << " maxid=" << set.maxid() << srnl;   

   sr_out << srnl << "Iterator test:" << srnl;
   set.remove(0);
   set.remove(5);
   sr_out << set << " maxid=" << set.maxid() << srnl;   

   SrSetIterator<MySetData> it ( set );
   for ( it.first(); it.inrange(); it.next() )
    sr_out<< it->s << srnl;
   for ( it.last(); it.inrange(); it.prior() )
    sr_out<< it->s << srnl;
 }

int set_main ( int, char ** )
 {
   run ();
   return 0;
 }

