
# include <SR/sr.h>
# include <SR/sr_var.h>
# include <SR/sr_var_table.h>

SrVar vb("vb.a",'b'), vi("vi",'i'), vf("vf",'f'), vs("vs",'s');

char data[] = "table [ vb.a=true true; vi=1 2; vf=-2.0; vs = aa bb; ]";

static void out ()
 {
   sr_out << vb << srnl;
   sr_out << vi << srnl;
   sr_out << vf << srnl;
   sr_out << vs << srnl;
   sr_out << srnl;
 }

void checkio ()
 {
   SrString buf;
   SrOutput o(buf);
   o << vb << vi << vf << vs;
   SrInput i(buf);
   i >> vb >> vi >> vf >> vs;
 }

int var_main ( int, char ** )
 {
   vb.push(true); vb.push(true); vb.push(false);
   vi.push(-10); vi.push(20); vi.push(-200);
   vf.push(-33.3); vf.push(2.314);
   vs.push("red"); vs.push("green"); vs.push("blue");

   out ();
   checkio ();
   out ();

   SrVarTable vt;
   vt.insert ( new SrVar(vb) );
   vt.insert ( new SrVar(vi) );
   vt.insert ( new SrVar(vb) );
   vt.insert ( new SrVar(vb) );
   vt.insert ( new SrVar(vf) );
   vt.insert ( new SrVar(vs) );

   sr_out << vt << srnl;

   vt.remove ( vt.search("vb.a") );
   vt.remove ( vt.search("vb.a") );

   sr_out << vt << srnl;

   SrInput i(data);
   i >> vt;
   sr_out << vt << srnl;

   return 0;
 }
