
# include <stdlib.h>

# include <FL/Fl.H>
# include <FL/fl_file_chooser.H>
# include <FL/fl_ask.H>

# include <SR/sr_model.h>
# include <SR/sr_sn_shape.h>
# include <SR/sr_sn_group.h>
# include <SR/sr_sn_matrix.h>
# include <SR/sr_sn_manipulator.h>
# include <SR/sr_viewer.h>
# include <SR/sr_string.h>

int manipulator_main ( int argc, char **argv )
 {
   SrViewer* viewer = new SrViewer ( 385, 50, 350, 280 );

   viewer->label ( "SrSnManipulator Test" );

   char *file="../data/knot.srm";
   SrSnModel* model = new SrSnModel;
   SrInput in ( fopen(file,"rt") );
   if ( !in.valid() || !model->shape().load(in) ) sr_out.fatal_error("Could not read model!\n");

   SrSnManipulator* manip = new SrSnManipulator;
   manip->child ( model );

   SrSnMatrix* mat = new SrSnMatrix;
   SrSnGroup* g = new SrSnGroup;

   g->add ( mat );
   g->add ( manip );

   mat->get().translation ( 0.5, 0, 0 );

   viewer->root ( g );
   viewer->view_all();
   viewer->menu_cmd ( SrViewer::CmdAxis );
   viewer->show();

   Fl::run();

   return 0;
 }
