 
# include <stdlib.h>

# include <FL/Fl.H>
# include <FL/fl_file_chooser.H>
# include <FL/fl_ask.H>

# include <SR/sr_model.h>
# include <SR/sr_sn_shape.h>
# include <SR/sr_viewer.h>

int viewer_main ( int argc, char **argv )
 {
    SrViewer* viewer = new SrViewer ( 385, 50, 350, 280 );
    viewer->label ( "SrViewer Demo" );

    char *file=0;
    file="../data/knot.srm";

    if ( argc>=2 )
     { file = argv[1];
     }
    else if ( !file )
     { file = fl_file_chooser ( "Enter srm file to load", "*.srm", 0 );
       if ( !file ) return 1;
     }

    SrInput in ( fopen(file,"rt") );
    SrSnModel *m = new SrSnModel;

    if ( !in.valid() || !m->shape().load(in) ) sr_out.fatal_error("Could not read model!\n");

    viewer->root ( m );
    viewer->view_all();
    viewer->show();

    Fl::run();

    return 0;
 }
