
# include <stdlib.h>

# include <FL/fl_ask.H>
# include <FL/fl_file_chooser.H>

# include "srxapp_main_win.h"
# include "srxapp_main.h"

# define SR_USE_TRACE1  // event tracing
# include <SR/sr_trace.h>

AppMainWin::AppMainWin ()
 {
 }

AppMainWin::~AppMainWin ()
 {
 }

void AppMainWin::show ()
 {
   ui_window->show();
 }

void AppMainWin::render ()
 {
   ui_viewer->render ();
 }

void AppMainWin::event ( Event e )
 {
   switch ( e )
    { case evFileOpen :
       { char *file = fl_file_chooser ( "Open File", "*.dat", 0 );
         if ( !file ) return;
         SrInput i ( fopen(file,"rt") );
         if ( !i.valid() ) { fl_alert ( "Could not open %s!", file ); break; }
         // load here the file...
         render ();
       } break;

      case evFileSave :
       { char *file = fl_file_chooser ( "Save File", "*.dat", 0 );
         if ( !file ) return;
         SrOutput o ( fopen(file,"wt") );
         if ( !o.valid() ) { fl_alert ( "Could not save %s!", file ); break; }
         // save here the file
       } break;

      case evSlider :
       { ui_viewer->resolution ( (float)ui_slider->value() );
         ui_viewer->render ();
       } break;

      case evNext :
       { float r = ui_viewer->resolution()+0.1f;
         ui_viewer->resolution ( r );
         ui_slider->value ( r );
         ui_viewer->render ();
       } break;

      case evPrior :
       { float r = ui_viewer->resolution()-0.1f;
         ui_viewer->resolution ( r );
         ui_slider->value ( r );
         ui_viewer->render ();
       } break;

      case evFileExit : exit(0); break;

    }
 }

